<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Used to replace Microsoft Session variables
' The session variabes are saved in a Database table called site sessions
' The key is a random number called websess
' The key can be passed on a querystring, hidden field. It is not found then
' look in session variable websess
' next look in cookie websess
' last look in a physical file ipaddress_mmddyyyy.txt
'*********************************************************************************

const cookieDelimiter = "!+" ' data delimiter
const cookielesstrace = "No"
const cookielessdbtrace = "No" ' performance tracing
const xsavesessdualmode = "Yes" ' Use real sesion variables with site sessions
const xsavesessionfile = "No" ' use real physical file
const cookienullvalue = "**NULL**" '
const xsavesessionfilefolder = "" ' use real physical file

dim cookieRS, cookiesql
dim cookiemsg
dim websessvalue ' used in gateway returns
dim cookiedbc

'* Purpose:
'* Generates a random id for unique
'* identification
'* Return:
'* A string that is the combination
'* of a random number and the
'* number of seconds from 12/31/92
function GenerateRandomID()
   dim intRandomNumber 'Random number
   dim intSeconds 'Number of seconds from 12/31/92
   dim NewID 'This is the generated ID
   randomize
   intRandomNumber = int((100000 * rnd) + 1)
   intSeconds = datediff("s", "12/31/92", now)
   NewID = cstr(intRandomNumber) & cstr(intSeconds)
   GenerateRandomID = NewID
end function

'* Purpose:
'* Assigns an id for use by the rest of
'* the functions.
'* Return:
'* A random ID for use with the rest of
'* the application. 
function AssignWebsess()
   dim websess 'Unique ID
   dim FileSO 'File System Object
   dim CookiePath 'Path to directory containing reference files
   dim CookieFile 'File of unique id and name/value pairs
   websess = GenerateRandomID
   cookiemsg = ""
   CookieFileWriteLine("UserID*=*" & websess)
   CookieFileWriteLine("DateAssigned*=*" & now)
   CookieFileAdd websess
   cookieFiledbtrace "$session_AssignWebsess"
   AssignWebsess = websess
end function

' add message to cookie string
sub CookieFileWriteLine (msg)
   if cookiemsg<>"" then
      cookiemsg = cookiemsg & cookiedelimiter
   end if
   cookiemsg = cookiemsg & msg
end sub

' cookiemsg has string to be stored
sub CookieFileClose (sessionkey)
   if len(sessionkey) > 0 then
      dim cookiesql, sessiondate, sessiontime, sessionvalue, sessionnow

      '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
      dim indate, intime, indatetime
      AdjustDate indate
      AdjustTime intime
      indatetime = cdate(indate & " " & intime)

      '6.09 - added formatdatetime
      sessiontime = formatdatetime(intime, vbshorttime)
      sessionvalue = replace(cookiemsg, "'", "''")
      sessiondate = DateNormalize(indate)
      sessionnow = indatetime

      CookieOpenDatabase cookiedbc
      cookiesql = "Update sitesessions set "
      cookiesql = cookiesql & "sessiondate='" & sessiondate & "',"
      cookiesql = cookiesql & "sessiontime=" & "'" & sessiontime & "',"
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      cookiesql = cookiesql & "sessionvalue=" & ""& sqlserverprefixn &"'" & sessionvalue & "',"
      cookiesql = cookiesql & "sessionnow=" & "'" & sessionnow & "'"
      cookiesql = cookiesql & " where sessionkey='" & sessionkey & "'"
      cookiedbc.execute(cookiesql)
   end if
end sub

' create a new entry in sitesessions table
' The string has been created already
sub CookieFileAdd (sessionkey)
   dim cookiesql, sessiondate, sessiontime, sessionvalue, sessionnow

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   dim indate, intime, indatetime
   AdjustDate indate
   AdjustTime intime
   indatetime = cdate(indate & " " & intime)

   '6.09 - added formatdatetime
   sessiontime = formatdatetime(intime, vbshorttime)
   sessionvalue = replace(cookiemsg, "'", "''")
   sessiondate = DateNormalize(indate)
   sessionnow = indatetime

   CookieOpenDatabase cookiedbc
   cookiesql = "insert into sitesessions(sessiondate, sessiontime, sessionkey, sessionvalue, sessionnow) values("
   cookiesql = cookiesql & "'" & sessiondate & "',"
   cookiesql = cookiesql & "'" & sessiontime & "',"
   cookiesql = cookiesql & "'" & sessionkey & "',"
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   cookiesql = cookiesql & ""& sqlserverprefixn &"'" & sessionvalue & "',"
   cookiesql = cookiesql & "'" & sessionnow & "'"
   cookiesql = cookiesql & ")"
   cookiedbc.execute(cookiesql)
end sub

' Adds a name/value pair to the users  file.
sub ResponseCookies(ValueName, ValueData)
   dim FileSO 'File System Object
   dim websess
   dim CookieRS, cookiesql, sessionvalue
   dim LineCount 'Number of rows of text
   dim NewCount 'Row count for new file
   dim DelimiterStart 'Location of the delimiting string: *=*
   dim DataArray() 'Array to contain file contents
   dim cartdata
   dim lvaluename
   'on error resume next
   websess = GetWebSess
   lvaluename = lcase(valuename)
   cookieFiledbtrace "$session_write"
   CookieOpenDatabase cookiedbc
   cookiesql = "Select * from sitesessions where sessionkey='" & websess & "'"
   Set cookiers = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   cookiers.open cookiesql, cookiedbc, adOpenForwardOnly, adLockReadOnly
   if not cookiers.eof then
      sessionvalue = cookiers("sessionvalue")
      CookieCreateArray dataarray, linecount, sessionvalue
   else
      websess = GetWebSessForce
      shopinit
      ShopError "session has been lost. Please continue"
   end if
   CloseRecordSet cookiers
   cookiemsg = ""
   for NewCount = 0 to LineCount - 1
      DelimiterStart = instr(DataArray(NewCount), "*=*")
      if lValueName <> left(DataArray(NewCount), DelimiterStart - 1) then
         CookieFileWriteLine(DataArray(NewCount))
      end if
   next
   CartData = lValueName & "*=*" & ValueData
   CookieFileWriteLine(CartData)
   CookieFileClose websess
end sub

'* Purpose:
'* Retrieves the value of an object
'* Input:
'* UserID, name of object
'* Return:
'* The value of the object passed in
function RequestCookies( ObjectName)
   dim FileSO 'File System Object
   dim CookieSQL 'Path to directory containing reference files
   dim CookieRS 'File of unique id and name/value pairs
   dim CookieFileText 'Text of the file
   dim CurrentData 'Current line of data
   dim DataLength 'Length of CurrentData
   dim DelimiterStart 'Location of the delimiting string: *=*
   dim CurrentName 'Name of current object
   dim ObjectValue 'Value of current object
   dim websess, sessionvalue, dataArray, Linecount, i, found
   websess = GetWebSess
   dim lobjectname
   lobjectname = lcase(objectname)
   objectvalue = ""
   cookieFiledbtrace "$session_read"
   CookieOpenDatabase cookiedbc
   cookiesql = "Select * from sitesessions where sessionkey='" & websess & "'"
   Set cookiers = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   cookiers.open cookiesql, cookiedbc, adOpenForwardOnly, adLockReadOnly
   if not cookiers.eof then
      sessionvalue = cookiers("sessionvalue")
      CookieCreateArray dataarray, linecount, sessionvalue
   else
      websess = GetWebSessForce
      shopinit
      ShopError "session has been lost. Please continue"
   end if
   CloseRecordSet cookiers
   cookiemsg = ""
   found = false
   for i = 0 to linecount -1
      CurrentData = dataArray(i)
      DataLength = len(CurrentData)
      DelimiterStart = instr(CurrentData, "*=*")
      CurrentName = left(CurrentData, DelimiterStart - 1)
      if lObjectName = CurrentName then
         ObjectValue = right(CurrentData, DataLength - (DelimiterStart + 2))
         found = true
         exit for
      end if
   next

   if found = True then
      RequestCookies = ObjectValue
   else
      RequestCookies = ""
   end if
end function

'* Purpose:
'* Retrieves all of the data associated
'* with the UserID
'* Input:
'* UserID
'* Return:
'* All of the contents of the file
sub CookieSessionList
   dim CurrentData 'Current line's contents
   dim websess
   websess = GetWebSess
   dim sessionvalue, dataarray, i
   CookieOpenDatabase cookiedbc
   dim currentname, objectvalue
   cookiesql = "Select * from sitesessions where sessionkey='" & websess & "'"
   Set cookiers = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   cookiers.open cookiesql, cookiedbc, adOpenForwardOnly, adLockReadOnly
   if not cookiers.eof then
      sessionvalue = cookiers("sessionvalue")
      CookieCreateArray dataarray, linecount, sessionvalue
   else
      DebugWrite "Cookie Sessionlist Record not found " & sessionvalue
   end if
   CloseRecordSet cookiers
   for i = 0 to linecount -1
      CurrentData = dataArray(i)
      DataLength = len(CurrentData)
      DelimiterStart = instr(CurrentData, "*=*")
      CurrentName = left(CurrentData, DelimiterStart - 1)
      ObjectValue = right(CurrentData, DataLength - (DelimiterStart + 2))
      response.write currentname & "=" & objectvalue & "<br>"
   next
end sub

'* Purpose:
'* Deletes an object from the data file
'* Input:
'* UserID, and ObjectName
'* Return:
'* All of the contents of the file
function DeleteData(ObjectName)
   dim FileSO
   dim websess 'File System Object
   dim CookiePath 'Path to directory containing reference files
   dim CookieFile 'File of unique id and name/value pairs
   dim CookieFileText 'Text of the file
   dim LineCount 'Number of rows of text
   dim DelimiterStart 'Location of the delimiting string: *=*
   dim NewCount 'Row count for new file
   dim OriginalObjectExists 'Flag to determine if object was in file
   dim DataArray() 'Array to contain file contents
   dim sessionvalue
   websess = GetWebSess
   CookieOpenDatabase cookiedbc
   cookiesql = "Select * from sitesession where sessionkey=" & websess
   Set cookiers = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   cookiers.open sql, cookiedbc, adOpenForwardOnly, adLockReadOnly
   if not cookiers.eof then
      sessionvalue = cookiers("sessionvalue")
      CookieCreateArray dataarray, linecount, sessionvalue
   else
      DebugWrite "Record not found " & websess
   end if
   CloseRecordSet cookiers
   cookiemsg = ""
   for NewCount = 0 to LineCount - 1
      DelimiterStart = instr(DataArray(NewCount), "*=*")
      if ObjectName <> left(DataArray(NewCount), DelimiterStart - 1) then
         CookieFileWriteLine(DataArray(NewCount))
      else
         OriginalObjectExists = "Yes"
      end if
   next
   CookieFileClose websess
end function

'* Purpose:
'* Grabs the data associated with the UserID and creates
'* hidden form elements.
'* Input: The assigned user id
'* Return: Writes out the form element
'* using the Response object.
function CreateHiddenElements
   dim websess
   websess = GetWebSess
   response.write "<INPUT TYPE=""hidden"" NAME=" & chr(34) & "websess" & chr(34) & " VALUE=" & chr(34) & websess & chr(34) & ">" & vbcrlf
end function

'* Purpose:
'*  Takes cart array and turns into astring delimited by |
'*  writes string to cookie file
sub ResponseCookiesCart (field, value)
   dim expires
   dim cartcount, arrcount, dataarea, j, countkeyname
   dim keyname, deliveryvalue
   dim i
   dim CartAttributes
   cookieFiledbtrace "$session_writecart"
   CartAttributes = cMaxCartAttributes
   cartcount = GetSess("CartCount")
   if cartcount = "" then exit sub
   if cartcount = 0 then exit sub
   for i = 1 to cartcount
      dataarea = ""
      for j = 1 to CartAttributes
         if j = cDelivery then
            CookieSaveDelivery value(j, i), deliveryvalue
            dataArea = dataarea & deliveryvalue & "|"
         elseif j = cUnitPrice then
		    '700 - Database Sessions For SQL Server
		    if isnumeric(value(j, i)) = false then
			   value(j, i) = 0
			end if
			dataArea = dataarea & value(j, i) & "|"
         else
            dataArea = dataarea & value(j, i) & "|"
         end if
      next

      keyname = field & cstr(i)
      ResponseCookies keyname, dataarea
   next
   countkeyname = "CartCount"
   ResponseCookies countkeyname, cartcount
end sub

'* Purpose:
'*  Takes string version of cart array and turns into an array
sub RequestCookieCart (field, value, rc)
   dim arrcount, dataarea, Temparray(29), tempcount
   dim ArrCart, cartcount, deliveryvalue
   dim i, j, keyname, countkeyname
   dim CartAttributes
   CartAttributes = cMaxCartAttributes
   rc = 0
   cookieFiledbtrace "$session_readcart"
   
   '700 - 2010.05.31 - Enahncement: xmaxcartitems limited to maximum 100
   redim ArrCart(CartAttributes, getconfigxmaxcartitems)
   
   value = ArrCart
   countkeyname = "CartCount"
   cartcount = RequestCookies(countkeyname)
   rc = 4
   value = ArrCart
   if cartcount = "" then exit sub
   if cartcount = 0 then exit sub
   for i = 1 to cartcount
      keyname = field & cstr(i)
      dataarea = RequestCookies(keyname)
      ParseRecord dataarea, TempArray, tempcount, "|"
      for j = 1 to CartAttributes
         if j = cDelivery then
            CookieRestoreDelivery temparray(j -1), deliveryvalue
            value(j, i) = deliveryvalue
         elseif j = cUnitPrice then
		    '700 - Database Sessions For SQL Server
		    if isnumeric(temparray(j -1)) = false then
			   temparray(j -1) = 0
			end if
		    value(j, i) = temparray(j -1)
		 else
            value(j, i) = temparray(j -1)
         end if
      next
   next
end sub

'* Purpose:
'*  Takes and array, turns into a string and saves string as a cookie
sub ResponseCookiesArray (field, value)
   dim dataarea, key, keycount, i, newvalue
   key = field
   if ucase(key) = "CARTARRAY" then
      ResponseCookiesCart field, value
      exit sub
   end if

   '700 - 2010.06.28 - Bug Fix: Error while using template manager & xsavesession is Yes
   on error resume next

   keycount = ubound(value)
   dataarea = ""
   for i = 0 to keycount
      dataarea = dataarea & value(i) & "|"
   next
   ResponseCookies field, dataarea
end sub

'* Purpose:
'* Deletes entire file
function DeleteCookieData
   '700 - 2010.06.10 - Enhancement: Better session handling while using xsavesession
   if lcase(xsavesession) <> "yes" then exit function
   dim FileSO
   dim websess 'File System Object
   dim CookiePath 'Path to directory containing reference files
   dim CookieFile 'File of unique id and name/value pairs
   dim CookieFileText 'Text of the file
   dim LineCount 'Number of rows of text
   dim DelimiterStart 'Location of the delimiting string: *=*
   dim NewCount 'Row count for new file
   dim OriginalObjectExists 'Flag to determine if object was in file
   dim DataArray() 'Array to contain file contents
   websess = GetWebSess
   cookiesql = "delete from sitesessions where sessionkey='" & websess &"'"
   CookieOpenDatabase cookiedbc
   cookiedbc.execute(cookiesql)
end function

sub CookieRestoreDelivery (istring, deliveryarray)
   deliveryarray = ""
   if GetConfig("xdeliveryAddress")<>"Yes" then exit sub
   if istring = "" then exit sub
   istring = replace(istring, "!", deliverydelimiter)
   ConvertDeliveryToArray DeliveryArray, istring
end sub

sub CookieSaveDelivery (deliveryarray, returnvalue)
   returnvalue = ""
   if GetConfig("xdeliveryAddress")<>"Yes" then exit sub
   if not isarray(deliveryarray) then exit sub
   ConvertDeliveryToString DeliveryArray, returnvalue
   returnvalue = replace(returnvalue, deliverydelimiter, "!")
end sub

' parse long string into an array
sub CookieCreateArray (words, wordcount, record)
   dim pos
   dim recordl
   dim temprec
   dim maxwords
   dim i
   dim maxentries
   dim finished
   dim length
   dim fieldvalue, delimstart

   maxwords = CookieFindOccurances(record, cookiedelimiter)
   maxwords = maxwords + 10
   redim words(maxwords)
   temprec = record
   finished = false
   pos = 1
   wordcount = 0
   ' make sure word array is null
   maxentries = ubound(words)
   for i = 0 to maxentries - 1
      words(i) = ""
   next
   recordl = len(temprec)
   do
      delimstart = instr(pos, temprec, cookiedelimiter)
      if delimstart>0 then
         length = delimstart - pos
         fieldvalue = mid(temprec, pos, length)
         words(wordcount) = fieldvalue
         pos = delimstart + 2
         wordcount = wordcount + 1
      else
         if Pos<recordl then
            length = recordl - pos + 1
            fieldvalue = mid(temprec, pos, length)
            words(wordcount) = fieldvalue
            wordcount = wordcount + 1
         end if
         finished = true
      end if
      if wordcount > maxentries then exit sub
   loop until finished = true
end sub

sub CookieOpenDatabase (connection)
   dim DatabaseType
   DatabaseType = ucase(xDatabaseType)
   if DatabaseType = "" or DatabaseType = "DRIVE" then
      CookieProcessAccessOpen connection
      exit sub
   end if
   if DatabaseType = "ODBC" then
      CookieProcessODBC connection
      exit sub
   end if
   if instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      CookieProcessSQLServer connection
      exit sub
   end if
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      CookieProcessMYSQLServer connection
      exit sub
   end if
end sub

' Open Access Database
sub CookieProcessAccessOpen(connection)
   dim DbLocation
   dim strconn
   dim Database
   if xsavesessionDatabase = "" then
      Database = xDatabase & ".mdb" ' Database name
   else
      Database = xsavesessionDatabase & ".mdb"
   end if
   DbLocation = xDbLocation
   if DbLocation<>"" then
      Database = DbLocation & "\" & Database
   end if
   if ucase(xDatabaseType) = "DRIVE" then
      if xAccessOLE<>"Yes" then
         strconn = "DRIVER=Microsoft Access Driver (*.mdb);DBQ=" & Database
      else
         strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & Database
      end if
   else
      if xAccessOLE<>"Yes" then
         strconn = "DRIVER=Microsoft Access Driver (*.mdb);DBQ=" & Server.MapPath(Database)
      else
         strconn = "provider=microsoft.jet.oledb.4.0;persist security info=false;data source=" & Server.MapPath(Database)
      end if
   end if
   set connection = Server.createobject("ADODB.Connection")
   if xsqlpwd = "" then
      connection.open strConn
   else
      connection.open strConn, xsqluser, xsqlpwd
   end if
end sub

sub CookieProcessODBC (connection)
   dim strconn
   set connection = Server.createobject("ADODB.Connection")
   strconn = xDatabase
   connection.open strConn
end sub

' Open SQL Server
sub CookieProcessSQLServer(connection)
   set connection = Server.createobject("ADODB.Connection")
   dim varServerIP, varUserName, varPassword, varDatabaseName
   dim strconn
   varServerIP = xSQLServer
   varUserName = xSQLUser
   varPassword = xSQLPwd
   varDatabaseName = xDatabase
   if xSqlOLEDb = "Yes" then
      strconn = "Provider=sqloledb;" & "Source=" & varServerIP & ";" & "Database=" & varDatabaseName & ";" & "UID=" & varUserName & ";" & "Password=" & varPassword & ";"
   else
      strconn = "DRIVER={SQL Server}; Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword'
   end if
   Connection.open strconn
end sub

' Open MYSQL
sub CookieProcessMYSQLServer(connection)
   set connection = Server.createobject("ADODB.Connection")
   dim varServerIP, varUserName, varPassword, varDatabaseName
   varServerIP = xSQLServer
   varUserName = xSQLUser
   varPassword = xSQLPwd
   varDatabaseName = xDatabase
   dim mysqlconn
   on error resume next
   if ucase(xDatabaseType) = "MYSQL351" then
      mysqlconn = "DRIVER={MYSQL ODBC 3.51 Driver};"
   elseif ucase(xDatabaseType)="MYSQL510" then
      mysqlconn="DRIVER={MySQL ODBC 5.1 Driver}; "
   else
      mysqlconn="DRIVER={MySQL}; "
   end if
   mysqlconn = mysqlconn & " Server=" & varServerIP & "; Database=" & varDatabaseName & "; UID=" & varUserName & "; PWD=" & varPassword
   Connection.open mysqlconn
end sub

' how man session variables do we have
function CookieFindOccurances(inputstring, findstring)
   'Returns the number of occurances of findstring that exist in the input string
   dim i, pos, findcounter
   pos = 0
   findcounter = 0
   i = 1
   do while i < len(inputstring)
      pos = instr(i, inputstring, findstring)
      if pos>0 then
         findcounter = findcounter + 1
         i = pos + len(findstring)
      else
         'no more occurances found, end loop
         i = len(inputstring) + 1
      end if
   loop
   CookieFindOccurances = findcounter + 1
end function

' the web session is known. We save it so we can find it agaian
' save as session variable and real cookie
sub SaveSessionVariable (userid)
   dim filename, cookiename
   ' save it in session variable
   session("websess") = userid
   cookiename = "websess_" & xShopId ' so two different sites do not intefere
   ' save as real cookie
   ' 701 - 2011.05.09 - should always initial session config values
   initsessionvalues
   if xsavesessioncookie = "Yes" then
      response.cookies(cookiename) = userid
	  '700 - Database Sessions For SQL Server - bugs
      response.cookies(cookiename).expires = date() + clng(xsavesessionexpirydays)
   end if
   ' save in physical file
   if xsavesessionfile = "Yes" then
      cookielessGenerateFilename filename
      CookielessWritefile userid, filename
   end if
end sub

' filename= datetime_mmddyy_hhmmss.txt
sub cookielessGenerateFilename (filename)
   dim prefix, mm, yy, dd, today, hh, nn, ss, tempname
   dim ipaddress

   'Security Patch - 2 June 2008
   ipaddress = CleanChars(request.servervariables("REMOTE_HOST"))

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   today = getnowindate

   prefix = "websess_" & xShopId
   mm = datepart("m", today)
   dd = datepart("d", today)
   yy = datepart("yyyy", today)
   hh = datepart("h", today)
   if len(mm) = 1 then mm = "0" & mm
   if len(dd) = 1 then dd = "0" & dd
   if len(hh) = 1 then hh = "0" & hh
   tempname = prefix & "_" & mm & dd & yy & "_" & Ipaddress
   tempname = tempname & ".txt"
   tempname = xsavesessionfilefolder & "\" & tempname
   filename = tempname
end sub

sub CookielessWriteFile ( userid, filename)
   dim fso, myfile, rc
   set fso = createobject("Scripting.FileSystemObject")
   set Myfile = fso.opentextfile(filename, 2, True)
   if err.number> 0 then
      rc = 4
   else
      MyFile.writeline userid
      rc = 0
   end if
   myfile.close
   set myfile = nothing
   set fso = nothing
end sub

sub CookielessreadFile ( userid, filename)
   dim fso, myfile, rc
   set fso = createobject("Scripting.FileSystemObject")
   'on error resume next
   set Myfile = fso.opentextfile(filename, 1, false)
   if err.number> 0 then
      response.write "<span class='fontbold'>" & "unable to open file" & filename & "<br>" & err.description & "</span>"
      rc = 4
   else
      userid = myfile.readline
      rc = 0
   end if
   myfile.close
   set myfile = nothing
   set fso = nothing
end sub

' try to find websess by reading a file
function Requestcookiefile
   dim userid, filename
   cookielessGenerateFilename filename
   CookielessreadFile userid, filename
   if cookielesstrace = "Yes" then
      DebugWrite "readcookfile returned " & userid & " from " & filename
   end if
   requestcookiefile = userid
end function



' Purpose: find the current websess.
' Hopefully it exists on form, querystring or session variable
'  Takes string version of cart array and turns into an array
' This has been totally rewriiten to find websess.
' It could be in:
' session variables if cookies are enabled and no web farm swtich
' It could be on querystring if passed
' it could be on a hidden field
' It could be a real cookie
' If file cookies are used, it could be in a physical file
' If we cannot find it, then we create a new web session using AssignWebsess
function GetWebSess
   dim userid, cookiename
   ' Try session variable
   userid = session("websess") ' is it  areal session variable
   if userid<>"" then
      GetWebSess = userid
      exit function
   end if
   ' Try querystring or hidden field

   '6.50 - precautionary security fix
   userid = CleanChars(request("websess"))
   if trim(userid) = "" then userid = session("seowebsess")
   if userid<>"" then
   
      'check is it in the cookie, if not create a new cookie
	  cookiename = "websess_" & xShopId
	  dim realusercookieid
	  realusercookieid = CleanChars(request.cookies(cookiename))
	  
	  if userid <> realusercookieid then

         if realusercookieid <> "" then
            CookielessReloadSession realusercookieid ' if whole session is load reload all variables
            GetWebSess = realusercookieid
            session("websess") = realusercookieid
            exit function
         end if

         userid = AssignWebsess ' need to assign a new web sess
         if cookielesstrace = "Yes" then
            DebugWrite "New websess created " & userid
         end if
         SaveSessionVariable userid ' save it away as cookie or file
         GetWebSess = userid
         exit function
	  end if
   
      GetWebSess = userid
      exit function
   end if
   ' Try real cookie
   cookiename = "websess_" & xShopId ' so two different sites do not intefere

   'Security Patch - 2 June 2008
   userid = CleanChars(request.cookies(cookiename))

   if userid<>"" then
      CookielessReloadSession userid ' if whole session is load reload all variables
      GetWebSess = userid
      session("websess") = userid
      exit function
   end if
   ' Try cookie in a file
   if xsavesessionfile = "Yes" then ' must be configired to try physical file
      userid = requestcookiefile ' try and find it
      if userid<>"" then ' did we get it
         CookielessReloadSession userid ' if whole session is load reload all variables
         session("websess") = userid
         GetWebSess = userid ' return value
         exit function
      end if
   end if
   ' someone stored it away such as gateway
   userid = websessvalue ' last resort gateway put something here
   if userid<>"" then
      GetWebSess = userid
      session("websess") = userid
      exit function
   end if
   userid = AssignWebsess ' need to assign a new web sess
   if cookielesstrace = "Yes" then
      DebugWrite "New websess created " & userid
   end if
   SaveSessionVariable userid ' save it away as cookie or file
   GetWebSess = userid
   exit function
end function

'lost Database, need to assign a new websess
function GetWebSessForce
   dim userid
   userid = AssignWebsess ' need to assign a new web sess
   if cookielesstrace = "Yes" then
      DebugWrite "New websess created " & userid
   end if
   SaveSessionVariable userid ' save it away as cookie or fil
   GetWebSessforce = userid
end function

' trace number of times an event occurs
sub cookieFiledbtrace (keyword)
   dim tempcount
   tempcount = session(keyword)
   if tempcount = "" then tempcount = 0
   tempcount = tempcount + 1
   session(keyword) = tempcount
end sub

' this is an optimization
' if using dual mode and the websess had to be found via cookie or file
' we probabaly have lost everything.  So reload all session variables from
' Database
sub CookielessReloadsession(websess)
   dim CookieSQL 'Path to directory containing reference files
   dim CookieRS 'File of unique id and name/value pairs
   dim CookieFileText 'Text of the file
   dim CurrentData 'Current line of data
   dim DataLength 'Length of CurrentData
   dim DelimiterStart 'Location of the delimiting string: *=*
   dim CurrentName 'Name of current object
   dim CurrentValue 'Value of current object
   dim sessionvalue, dataArray, Linecount, i, found
   dim lobjectname
   if xsavesessdualmode<>"Yes" then exit sub
   cookieFiledbtrace "$session_reloadsessionvariables"
   CookieOpenDatabase cookiedbc
   cookiesql = "Select * from sitesessions where sessionkey='" & websess & "'"
   Set cookiers = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   cookiers.open cookiesql, cookiedbc, adOpenForwardOnly, adLockReadOnly
   if not cookiers.eof then
      sessionvalue = cookiers("sessionvalue")
      CookieCreateArray dataarray, linecount, sessionvalue
   else
      CloseRecordSet cookiers
      exit sub
   end if
   CloseRecordSet cookiers
   ' first two values are internal useri9d and date. no need to restore
   for i = 2 to linecount -1
      CurrentData = dataArray(i)
      DataLength = len(CurrentData)
      DelimiterStart = instr(CurrentData, "*=*")
      CurrentName = left(CurrentData, DelimiterStart - 1)
      Currentvalue = right(CurrentData, DataLength - (DelimiterStart + 2))
      session(currentname) = currentvalue
   next
end sub
%>